/*  SVGATextMode -- An SVGA textmode manipulation/enhancement tool
 *
 *  Copyright (C) 1995-1998  Koen Gadeyne
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


/***
 *** Config file data structures for SVGATextMode.
 *** These will hold all the data degenerated by the parser
 ***
 *** This needs only be included by the main program. All others 
 *** can include cfg_structs.h for struct types
 ***/

#ifndef _CFG_DATA_H
#define _CFG_DATA_H

#include "cfg_structs.h"

t_mode *text_mode_list=NULL;
t_mon_timing *h_mon_limits=NULL;
t_mon_timing *v_mon_limits=NULL;
t_terminals *p_terminals=NULL;
t_clockdef clock_data = INIT_CLOCKDEF;
t_fontdef font_data = INIT_FONTDATA;
int chipset = CS_NONE;
int underline_pos=-1; /* no underlining is default */
int bordercolor = 0;
int cursor_start=29, cursor_end=31;
char *resetprogpath=NULL;
char *defaultmode;
int STM_Options;

#endif
